/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.crop.clm;

import java.util.List;
import org.openide.util.lookup.ServiceProvider;

/**
 * Provides crops from the CLM web service
 * @author Merijn Zengers
 */
@ServiceProvider(service=ClmCropService.class)
public class ClmCropServiceImpl implements ClmCropService{
    
    private ClmCropClient client;
    
    /**
     * Gets a list of crop names  
     * @return List<String> Names of crops
     */
    @Override
    public List<String> getCropNames() {
        client = new ClmCropClient();
        ClmUnmarshaller unmarshaller = new ClmUnmarshaller();
        CropMessage cropMessage = unmarshaller.unMarshall(client.getCrops(String.class));
        client.close();
        
        List<String> cropNames = null;
        
        if(cropMessage != null){
            //TODO: .getCrops().get(0).getCrop() .... Refactor to something that does make sense...
            cropNames = cropMessage.getCrops().get(0).getCrop();
        }
        
        return cropNames;
    }
    
}
